clear

********************************************
@ 07,59 say "CLIPPER BASICO"

@ 03,01 say "PROC01 Clipper               "
@ 04,01 say "                             "
@ 05,01 say "PROC11 Harbour Local  DBF    "
@ 06,01 say "PROC12 Harbour Remoto DBF    "
@ 07,01 say "PROC13 Harbour Remoto MYSQL  "
@ 08,01 say "                             "
@ 09,01 say "PROC21 xHarbour Local  DBF   "
@ 10,01 say "PROC22 xHarbour Remoto DBF   "
@ 11,01 say "PROC23 xHarbour Remoto MYSQL "
@ 12,01 say ""

@ 16,01 say "Ŀ"
@ 17,01 say "- Testando os campos bsicos "
@ 18,01 say "- Clculo de Data + Dias     "
@ 19,01 say "- Incluso/Alterao/Excluso"
@ 20,01 say "- Uso DbEdit para Consulta   "
@ 21,01 say ""

******************************************************************
******************************************************************
* CLIPPER
******************************************************************
******************************************************************

***************************************************** TELA E SET BASICO
   set date brit
   set epoch to 2001
   set delete on
   @ 02,01 to 02,80
   @ 23,01 to 23,80
   set color to w/b
      @ 01,01 say space(80)
      @ 01,01 say "LOTES - Aprendizado Harbour e xHarbour"
      @ 01,70 say date()
   set color to w/n
   memoria = memory()
   @ 03,54 say memory() pict "9,999,999,999"
   @ 03,68 say "Kb Memria"
   dc = " "

***************************************************** ABERTURA DE ARQUIVOS
   sele a
      use lotes alias lotes
         index on lote                                to ilote1
         index on estado+lote+dt_entrada              to ilote2
         index on dt_entrada+lote                     to ilote3
         index on dt_saida+lote                       to ilote4
      set index to ilote1, ilote2, ilote3, ilote4
      go top
      set order to 1
   sele b
      use estado alias estado
         index on sigla_uf                            to iuf1
      go top
      set order to 1

***************************************************** OPERACAO
   wlote       = space(07)
   westado     = space(02)
   wdt_entrada = datavol4(space(08))
   wdias       = 0
   wdt_saida   = datavol4(space(08))
   wqtde       = 0
   wvlr_unit   = 0
   wvlr_total  = 0

   do while .t.

      msg_1 ( "Informe o LOTE                              [branco] finaliza" )
      @ 09,34 say "Ŀ"
      @ 10,34 say " Lote....:           ? Pesquisa "
      @ 11,34 say "                                      "
      @ 12,34 say " Estado..:       "
      @ 13,34 say "                                      "
      @ 14,34 say "   Entrada       Dias     Devoluo   "
      @ 15,34 say "              "
      @ 16,34 say " //   +    = //   "
      @ 17,34 say "                                      "
      @ 18,34 say "    Qtde      Unitrio    Valor Total "
      @ 19,34 say "        "
      @ 20,34 say "  x . = . "
      @ 21,34 say ""
      @ 22,34 say "                                        "

      @ 10,46 get wlote pict "@!"
      read
      if wlote = " "
         clear
         return
      endif
      if wlote = "?"
         consulta()
         loop
      endif

      ******************************* consulta
      sele lotes
         set order to 1
         go top
      seek (wlote)

      if .not. eof()
         westado     = estado
         wdt_entrada = datavol4(dt_entrada)
         wdias       = dias
         wdt_saida   = datavol4(dt_saida)
         wqtde       = qtde
         wvlr_unit   = vlr_unit
         wvlr_total  = vlr_total

         set color to g+/n
            @ 12,46 say westado
            @ 16,36 say wdt_entrada
            @ 16,52 say wdias        pict "9999"
            @ 16,60 say wdt_saida
            @ 20,36 say wqtde        pict "9,999.999"
            @ 20,48 say wvlr_unit    pict "9,999.999"
            @ 20,60 say wvlr_total   pict "9,999,999.99"
            sele estado
               set order to 1
               go top
            seek (westado)
            if eof()
               alert ( "Erro - deveria existir o ESTADO" )
            else
               @ 12,49 say estado
            endif
            sele lotes
         set color to w/n

         msg_1 ( "Registro existente. Deseja Alterar, Excluir ou Voltar ? ... A/E/V ..." )
         @ 24,73 get dc pict "!" valid dc $ "AEV"
         read
         if upper(dc) = "V"
            loop
         elseif upper(dc) = "A"
            woquefazer = "ALT"
         elseif upper(dc) = "E"
            woquefazer = "EXC"
         endif
      else
         woquefazer = "INC"
      endif

      ******************************* exclusao
      if woquefazer = "EXC"
         msg_3 ( "Confirma a excluso do Lote " + rtrim(wlote) + " ? ... S/N ..." )
         if upper(dc) = "S"
            sele lotes
               set order to 1
               go top
            seek (wlote)
            if eof()
               alert ( "Erro - chamar CPD - registro no existe mais" )
            else
               delete
            endif
         endif
         loop
      endif

      ******************************* inclusao e alteracao
      set color to g+/n
         if woquefazer = "INC"
            @ 22,35 say "Registro Novo"
         elseif woquefazer = "ALT"
            @ 22,35 say "Edio de Registro"
         endif
      set color to w/n

      pede_campo = "01"
      preenche = "S"
      do while preenche = "S"

         if pede_campo = "01"
            msg_1 ( "Informe o ESTADO                            [branco] abandona" )
            @ 12,46 get westado pict "@!"
            read
            if westado = " "
               msg_3 ( "Deseja abandonar este registro ? ... S/N ..." )
               if upper(dc) = "S"
                  preenche = "ABANDONA"
               endif
               loop
            endif

            sele estado
               set order to 1
               go top
               seek (westado)
            if eof()
               alert ( "Estado no encontrado" )
               loop
            else
               set color to g+/n
                  @ 12,49 say estado
               set color to w/n
            endif
            pede_campo = "02"
         endif

         if pede_campo = "02"
            msg_1 ( "Informe a Data de Entrada                   [branco] retorna campo anterior" )
            @ 16,36 get wdt_entrada
            read
            if dtos(wdt_entrada) = space(08)
               pede_campo = "01"
            elseif wdt_entrada > date() .or. dtos(wdt_entrada) < "20150101"
               loop
            else
               pede_campo = "03"
            endif
         endif

         if pede_campo = "03"
            msg_1 ( "Informe o prazo em DIAS para devoluo do lote" )
            @ 16,52 get wdias        pict "9999" valid wdias > 0
            read

            * calcula wdt_saida
            wdt_saida = wdt_entrada + wdias
            set color to g+/n
              @ 16,60 say wdt_saida
            set color to w/n
            pede_campo = "04"
         endif

         if pede_campo = "04"
            msg_1 ( "Informe a Quantidade e Preo Unitrio         [zero] retorna campo anterior" )
            @ 20,36 get wqtde                pict "9,999.999" valid wqtde >= 0
            @ 20,48 get wvlr_unit            pict "9,999.999" valid wvlr_unit >= 0
            read

            if wqtde = 0
               pede_campo = "02"
            else
               * calcula wvlr_total
               wvlr_total = wqtde * wvlr_unit
               set color to g+/n
                  @ 20,60 say wvlr_total        pict "9,999,999.99"
               set color to w/n
               pede_campo = "CONFIRMA_DADOS"
            endif
         endif

         if pede_campo = "CONFIRMA_DADOS"
            msg_3 ( "Confirma os dados ? ... S/N ..." )
            if upper(dc) = "S"
               preenche = "DADOS_OK"
            else
               msg_3 ( "Deseja continuar neste registro ? ... S/N ..." )
               if upper(dc) = "S"
                  pede_campo = "01"
                  loop
               endif
               preenche = "ABANDONA"
            endif
         endif
      enddo

      if preenche = "DADOS_OK"
         if woquefazer = "INC"
            sele lotes
            go bottom
            append blank
         elseif woquefazer = "ALT"
            sele lotes
               set order to 1
               go top
            seek (wlote)
            if eof()
               alert ( "Erro - chamar CPD - registro no existe mais" )
               loop
            endif
         endif
         rlock()
            replace lote         with wlote
            replace estado       with westado
            replace dt_entrada   with dtos(wdt_entrada)
            replace dias         with wdias
            replace dt_saida     with dtos(wdt_saida)
            replace qtde         with wqtde
            replace vlr_unit     with wvlr_unit
            replace vlr_total    with wvlr_total
         unlock
      endif
   enddo

*****************************************************************************
*****************************************************************************
proc msg_1 (w_msg)                  // Procedure: Mensagem Sistema SEM parada

   set color to w/n
      @ 24,01 say space(80)
   set color to gr+/n
      @ 24,03 say w_msg
   set color to w/n

return

*****************************************************************************
*****************************************************************************
proc msg_2 (w_msg)                  // Procedure: Mensagem Sistema COM parada

   set color to w/n
      @ 24,01 say space(80)
   set color to gr+/n
      @ 24,03 say w_msg
      inkey(0)
   set color to w/n
      @ 24,01 say space(80)            // Limpa apos a exibicao da mensagem

return

*****************************************************************************
*****************************************************************************
proc msg_3 (w_msg)                         // Procedure: Mensagem Com Retorno
                                           //          : SIM ou NAO
   set color to w/n
      @ 24,01 say space(80)
   set color to gr+/n
      dc = " "
      @ 24,03 say w_msg get dc pict "!" valid dc $ "SNsn"
      read
   set color to w/n
      @ 24,01 say space(80)            // Limpa apos a exibicao da mensagem

return

*****************************************************************************
*****************************************************************************
func datavol4                    // Funcao: Converte AAAAMMDD para dd/mm/aaaa
   * para chamar esta rotina:
   *        variavel = datavol4(campo texto no formato aaaammdd)
   *        a variavel acabou de ser criada como data
   *        deixar sempre SET CENTURY ON - trabalhar com 4 casas no ano
   *        quando gravar, utilizar DTOS(variavel data)
   *        portanto, no DBF o campo data sera TEXTO de 8 posicoes

   set century on
   parameters wdv_data
   w_data_dv = ctod(subst(wdv_data,7,2)+"/"+subst(wdv_data,5,2)+"/"+subst(wdv_data,1,4))

return (w_data_dv)


   ******************************************************************
   ******************************************************************
   * SQL - comentario sobre as instrucoes
   ******************************************************************
   ******************************************************************

   ************************************************** MYSQL"
   *
   * if woquefazer = "PESQUISA"
   *    wsql =        "SELECT * FROM LOTES"
   *    wsql = wsql + " WHERE lote = wlote"
   * endif

   * if woquefazer = "INC"
   *    wsql =        "INSERT INTO LOTES ("
   *    wsql = wsql +    " lote, estado, dt_entrada, dias, dt_saida, qtde, vlr_unit, vlr_total"
   *    wsql = wsql + ") VALUES ("
   *    wsql = wsql +    "wlote,westado,wdt_entrada,wdias,wdt_saida,wqtde,wvlr_unit,wvlr_total)"
   * endif

   * if woquefazer = "ALT"
   *    wsql =        " UPDATE LOTES SET "
   *    wsql = wsql +   "estado=westado,"
   *    wsql = wsql +   "dt_entrada=wdt_entrada,"
   *    wsql = wsql +   "dias= wdias,"
   *    wsql = wsql +   "dt_saida=wdt_saida,"
   *    wsql = wsql +   "qtde=wqtde,"
   *    wsql = wsql +   "vlr_unit=wvlr_unit,"
   *    wsql = wsql +   "vlr_total=wvlr_total"
   *    wsql = wsql + " WHERE lote = wlote"

   * if woquefazer = "EXC"
   *    wsql =        " DELETE FROM LOTES"
   *    wsql = wsql + " WHERE lote = wlote"
